/****************************************************************************
 Include Section
*****************************************************************************/

#include "global.h"
#include "BfCacheTest.h"

#if defined __ICACHETEST__

/*****************************************************************************
 Symbolic constants / definitions
******************************************************************************/

/*****************************************************************************
 Variables
******************************************************************************/

/*****************************************************************************
 Prototypes
******************************************************************************/

.GLOBAL EXT_A;
.GLOBAL EXT_B;
.GLOBAL EXT_C;
.GLOBAL EXT_D;
.GLOBAL EXT_E;
.GLOBAL EXT_F;
.GLOBAL EXT_G;
.GLOBAL EXT_H;

/*****************************************************************************
 Functions
******************************************************************************/

.SECTION sdram;

/****************************************************************************
 Name:                  
 Description:           Cache Line Replacement Tests
                        All five functions are place at addresses that correspond
                        to the same Cache Line / Set by using "LDF_RESOLVE.h"
 Input Parameters:      none
 Return Parameters:     none
 Registers Used:        R7:0,P5:4,LC0/1,LT0/1,LB0/1
 Global Registers Used: none
 C-Callable :           no
*****************************************************************************/

EXT_A:
jump EXT_B;
EXT_A.end:

EXT_B:
jump EXT_C;
EXT_B.end:

EXT_C:
jump EXT_D;
EXT_C.end:

EXT_D:
jump EXT_E;
EXT_D.end:

EXT_E:
jump EXT_F;
EXT_E.end:

EXT_F:
jump EXT_G;
EXT_F.end:

EXT_G:
jump EXT_H;
EXT_G.end:

EXT_H:
[--SP]=R7;
nop;R7=7;nop;R7=7;nop;R7=7;nop;R7=7;nop;R7=7;nop;R7=7;nop;
R7=[SP++];
rts;
EXT_H.end:


#endif /* defined __ICACHETEST__ */

/*****************************************************************************
 EOF
******************************************************************************/
