/****************************************************************************
 Include Section
*****************************************************************************/

#include "global.h"
#include "BfCacheTest.h"

#if defined __DCACHETEST__

/*****************************************************************************
 Symbolic constants / definitions
******************************************************************************/

#if defined LIMIT15kB
#undef SDRAM_LENGTH
#define SDRAM_LENGTH 0x3C00
#endif

/*****************************************************************************
 Variables
******************************************************************************/

/*****************************************************************************
 Prototypes
******************************************************************************/

.GLOBAL _BfDcacheTest;

/*****************************************************************************
 Functions
******************************************************************************/

.SECTION L1_code;


/****************************************************************************
 Name:                  _BfDcacheTest
 Description:           
 Input Parameters:      none
 Return Parameters:     none
 Registers Used:        R7,P5:4,B0,Loopreg
 Global Registers Used: none
 C-Callable :           no
*****************************************************************************/

_BfDcacheTest:
    link 0;
    [--SP] = ASTAT;
    [--SP] = (R7:0,P5:0);
    PUSH_DAG_REGx(0);
    PUSH_LOOP_REGx(0);


    #if defined DATA_CACHE_EN
        call __dflushinvall;
    #endif


    IMM32(P5,SDRAM_START);
    B0 = P5;
    IMM32(P4,SDRAM_LENGTH/4);

/*
    P5 = B0;
    lsetup(InitRd32,InitRd32) LC0 = P4;
    InitRd32:   R7 = [P5++];
*/

    P5 = B0;
    lsetup(InitWr32Addr,InitWr32Addr) LC0 = P4;
    InitWr32Addr:   [P5++] = P5;


    nop;nop;nop;nop;nop;


    P5 = B0;
    lsetup(Rd32,Rd32) LC0 = P4;
    Rd32:   R7 = [P5++];

/*
    P5 = B0;
    lsetup(Wr32,Wr32) LC0 = P4;
    Wr32:   [P5++] = P5;
*/

    POP_LOOP_REGx(0);
    POP_DAG_REGx(0);
    (R7:0,P5:0) = [SP++];
    ASTAT = [SP++];
    unlink;
    rts;
_BfDcacheTest.end:


#endif /* defined __DCACHETEST__ */


/*****************************************************************************
 EOF
******************************************************************************/
